<?php


// Form was Send
	if($_POST){
		handle_action();
	}

	load_plugin_textdomain('capa', $path='wp-content/plugins/capa');

#	$page_uri = $_SERVER['PHP_SELF'] . '?page=' . plugin_basename(__FILE__);
	$page_uri = 'admin.php?page=capa/capa-options.php';

	add_action('admin_menu', 'capa_add_pages');

#	echo $page_uri;

	function capa_add_pages() {
	// Add CaPa CSS Style
		wp_enqueue_style( 'capa', plugins_url( $path = '/capa/css/style.css'), array() );

	// Add a new top-level menu (ill-advised):
		$page['global'] =	add_menu_page( __('CaPa &rsaquo; Settings','capa'), 'CaPa', 8, __FILE__, 'capa_global_page','div');

	// Add a submenu to the custom top-level menu:
		$page['roles'] =	add_submenu_page(__FILE__, __(' CaPa &rsaquo; Roles','capa'), __('Roles','capa'), 8, 'sub-page', 'capa_sublevel_roles');

	// Add a second submenu to the custom top-level menu:
		$page['users'] =	add_submenu_page(__FILE__, __('CaPa &rsaquo; Anonymous Users','capa'), __('Anonymous User','capa'), 8, 'sub-page2', 'capa_sublevel_users');

	// Add Help 
		if (function_exists('add_contextual_help')) {
		  add_contextual_help($page['global'],'<br />'.__('At this Area you can set up the global Settings of CaPa','capa'));
		  add_contextual_help($page['roles'],'<br />'.__('At this Area you can set up the roles Settings of CaPa','capa'));
		  add_contextual_help($page['users'],'<br />'.__('This Settings is specific for the anonymous user. Use it wise','capa'));
		}
	}


// capa_global_page() displays the page content for the custom Capa Toplevel menu
	function capa_global_page() {
			echo '<h2 style="margin-bottom:15px;">' . __('CaPa Global Settings','capa') . '</h2>';
			echo '<form name="capa_protect" method="post" action="'.$page_uri.'">';
 			wp_nonce_field('update-options');

		  // --------------------------------------------------------------

			echo '<fieldset style="border:1px solid #CCCCCC; padding-left:10px;"><legend>'. __('Protected Posts in the Blog','capa') .'</legend>';

			echo '
			<script language="javascript">

			// Return the value of the radio button that is checked. Return an empty
			// string if none are checked, or there are no radio buttons

			function getCheckedValue(radioObj) {
				if(!radioObj)
					return "";
				var radioLength = radioObj.length;
				if (radioLength == undefined) {
					if (radioObj.checked)
						return radioObj.value;
					else
						return "";
				}
				for(var i = 0; i < radioLength; i++) {
					if(radioObj[i].checked)
						return radioObj[i].value;
				}
				return "";
			}

			function enable_disable_form_elements()
			{
				the_form = document.capa_protect;

			    private_message_div = document.getElementById("private_message_div");
				if (getCheckedValue(the_form.capa_protect_post_policy) == "show title") {
					private_message_div.style.color = "black";
					the_form.capa_protect_private_message.disabled = false;
					the_form.capa_protect_private_message.style.color = "black";
		//			the_form.capa_protect_show_padlock_on_private_posts.disabled = false;
				} else {
					private_message_div.style.color = "gray";
					the_form.capa_protect_private_message.disabled = true;
					the_form.capa_protect_private_message.style.color = "gray";
		//			the_form.capa_protect_show_padlock_on_private_posts.disabled = true;
				}

			    private_categories_div = document.getElementById("private_categories_div");
				if (the_form.capa_protect_show_private_categories.checked) {
					private_categories_div.style.color = "black";
					the_form.capa_protect_show_padlock_on_private_categories.disabled = false;
				} else {
					private_categories_div.style.color = "gray";
					the_form.capa_protect_show_padlock_on_private_categories.disabled = true;
				}
			}
			</script>

			';

			echo '<p><input type="radio" name="capa_protect_post_policy" onClick="enable_disable_form_elements()" value="hide"' .
				(get_option('capa_protect_post_policy') == 'hide' ||
				// For backwards compatibility
				get_option('capa_protect_post_policy') == false &&
				get_option('capa_protect_show_private_message') == false ? ' checked' : '') .
				'> '. __('Hide entire post.', 'capa') .'<br>';

			echo '<input type="radio" name="capa_protect_post_policy" onClick="enable_disable_form_elements()" value="show title"' .
				(get_option('capa_protect_post_policy') == 'show title' ? ' checked' : '') .
				'> '. __('Show title, but a private message for the body text.', 'capa') .'<br>';
		/*
			print '<input type="radio" name="capa_protect_post_policy" onClick="enable_disable_form_elements()" value="show message"' .
				(get_option('capa_protect_post_policy') == 'show message' ||
				// For backwards compatibility
				get_option('capa_protect_show_private_message') == true ? ' checked' : '') .
				"> ". __('Show a private message for the title and nothing for the body text.', 'capa') ."</p>\n";
		*/

			echo '<input type="radio" name="capa_protect_post_policy" onClick="enable_disable_form_elements()" value="show message"' .
			(get_option('capa_protect_post_policy') == 'show message' ||
			// For backwards compatibility
			get_option('capa_protect_show_private_message') == true ? ' checked' : '') .
			'> '. __('Show title and body text.', 'capa') .'</p>';

			echo '<div id="private_message_div">';

			$private_message = capa_protect::get_private_message();

			echo '<p>'. __('The private post message','capa') .':<br>' .
				'<input name="capa_protect_private_message" type="text" size="50"' .
				' value="'.$private_message.'" /></p>';
		/*

			print "<p><input name=capa_protect_show_padlock_on_private_posts type=checkbox" .
				 (get_option('capa_protect_show_padlock_on_private_posts') ? " checked" : "") .
				 "> ". __('Show a padlock icon on the private post message.','capa') ."</p>\n";
		*/
			echo '</div>';

			echo '</fieldset><br>';
		/*
			print "<fieldset style=\"border:1px solid #CCCCCC; padding-left:10px;\"><legend>". __('Category Extra', 'capa') ."</legend>\n";

		#	print "<fieldset style=\"border:1px solid #CCCCCC; padding-left:10px;\"><legend>". __('Protected Posts in Feeds', 'capa') ."</legend>\n";

		#	echo "<p>". __('Users can always see the entire feed in their web browser by logging into the blog and checking the <em>Remember me</em> option. This will store a cookie on their computer that will be read by wordpress when the browser requests the feed. However, for feed readers that do not have cookie support, you can set the following option to show the title but not the text of protected posts in your feeds.', 'capa') ."</p>";

		#	print "<p><input name=capa_protect_show_title_in_feeds type=checkbox " .
		#		(get_option('capa_protect_show_title_in_feeds') ? " checked" : "") .
		#		"> ". __('Show the title and links (but not the summary or content) instead of hiding posts.', 'capa') ."</p>\n";


		#	print "<h3>". __('The Category List','capa') ."</h3>\n";

			print "<p><input name=capa_protect_show_private_categories type=checkbox onClick='enable_disable_form_elements()'" .
				(get_option('capa_protect_show_private_categories') ? " checked" : "") .
				"> " . __('Show private categories.','capa') ."</p>\n";

			print "<div id=private_categories_div style='padding-left:2em'>\n";

			print "<p><input name=capa_protect_show_padlock_on_private_categories type=checkbox " .
				(get_option('capa_protect_show_padlock_on_private_categories') ? " checked" : "" ) .
				"> " . __('Show a padlock icon next to private categories.','capa') ."</p>\n";

			print '</div></fieldset><br>';
		*/
			// -----
				echo "<fieldset style=\"border:1px solid #CCCCCC; padding-left:10px;\"><legend>". __('The Category List','capa') ."</legend>\n";


				echo '<p><input name="capa_protect_show_private_categories" type="checkbox" onClick="enable_disable_form_elements()"' .
					(get_option('capa_protect_show_private_categories') ? " checked" : "") .
					'> ' . __('Show private categories','capa') .'</p>';

				echo '<div id="private_categories_div" style="padding-left:2em">';

				echo '<p><input name="capa_protect_show_padlock_on_private_categories" type="checkbox" '.
					(get_option('capa_protect_show_padlock_on_private_categories') ? " checked" : "" ) .
					'> ' . __('Show a padlock icon next to private categories','capa') .'</p>';

				echo '</div>';

				echo '</fieldset><br>';
			// -----
		
			// -----
				echo "<fieldset style=\"border:1px solid #CCCCCC; padding-left:10px;\"><legend>". __('Protected Comments in the Blog','capa') ."</legend>\n";

				echo "<p>". __('Public Comments','capa') . '</p>';

				echo '<p><input type="radio" name="capa_protect_comment_policy"  value="hide"' .
					(get_option('capa_protect_comment_policy') == 'hide' ? ' checked' : '') .
					'> '. __('Hide entire comment.', 'capa') .'<br>';

				echo '<input type="radio" name="capa_protect_comment_policy" value="show name"' .
					(get_option('capa_protect_comment_policy') == 'show name' ? ' checked' : '') .
					'> '. __('Show Author, but the private message for the body text.', 'capa') .'<br>';

				echo '<input type="radio" name="capa_protect_comment_policy" value="show message"' .
					(get_option('capa_protect_comment_policy') == 'show message' ? ' checked' : '') .
					'> '. __('Show body text, but no author.', 'capa') .'</p>';

				echo '<input type="radio" name="capa_protect_comment_policy" value="all"' .
					(get_option('capa_protect_comment_policy') == 'all' ? ' checked' : '') .
					'> '. __('Show everything.', 'capa') .'</p>';

				echo '<hr>';

				echo "<p>". __('Private Comments','capa') . '</p>';

				echo '<p><input name="capa_protect_show_comment_on_private_posts" type="checkbox" value="1" '.
					 (get_option('capa_protect_show_comment_on_private_posts') ? " checked" : "") .
					 '> '. __('Use the Settings for comments from hidden Posts.','capa') .'</p>';


				echo '</fieldset><br>';
			// -----

			// -----
				echo "<fieldset style=\"border:1px solid #CCCCCC; padding-left:10px;\"><legend>". __('Pages','capa') ."</legend>\n";

				echo '<p><input name="capa_protect_show_private_pages" type="checkbox" onClick="enable_disable_form_elements()"' .
					(get_option('capa_protect_show_private_pages') ? " checked" : "") .
					'> ' . __('Show private pages','capa') .'</p>';

				echo '</fieldset><br>';
			// -----


			echo '

		<script language="javascript">
		enable_disable_form_elements();
		</script>

		<p class="submit" style="float:left; margin-right: 10px;">
			<input type="submit" name="submit" value="'. __('Update Global Options','capa') .'  &raquo;" /> 
		</p>

		<p class="submit">
			<input type="submit" name="submit" value="'. __('Reset Global Options','capa').'" />
		</p>

		</form>
		';

	}

// capa_sublevel_roles() displays the page content for the roles submenu
	function capa_sublevel_roles() {
			echo '<div class="wrap">';
			echo '<h2 style="margin-bottom:15px;">' . __('CaPa Roles','capa') . '</h2>';

		  	// --------------------------------------------------------------


									$categorys	= get_categories('hide_empty=0&hierarchical=0');
			$category_check_role_editor 		= get_option("capa_protect_cat_role_editor");
			$category_check_role_author 		= get_option("capa_protect_cat_role_author");
			$category_check_role_contributor	= get_option("capa_protect_cat_role_contributor");
			$category_check_role_subscriber 	= get_option("capa_protect_cat_role_subscriber");

									$pages	= & get_pages('hierarchical=0');		
			$page_check_role_editor 		= get_option("capa_protect_pag_role_editor");
			$page_check_role_author 		= get_option("capa_protect_pag_role_author");
			$page_check_role_contributor	= get_option("capa_protect_pag_role_contributor");
			$page_check_role_subscriber 	= get_option("capa_protect_pag_role_subscriber");

	#		usort($categorys,"sort_category_ids_by_name");

			$odd[1] = ' background-color: #F1F1F1;';

			echo '
			<script language="javascript">
			function check_categories(class,checked)
			{
				the_form = document.capa_protect;

				all_check_boxes = the_form.getElementsByTagName(\'input\');

				for (var i = 0; i < all_check_boxes.length; i++)
					if (all_check_boxes[i].className == class)
						all_check_boxes[i].checked = checked;
			}
			</script>
			';

			echo '<form name="capa_protect" method="post" action="'.$page_uri.'">';

  // --------------------------------------------------------------
  // ---- Categories --- //
  // --------------------------------------------------------------

			echo '
			
				<table class="form-table">
					<thead style="background:#E6E6E6;">
						<tr>
							<th><b>'.__('Categories','capa').'</b></th>
							<th style="text-align:center;">'.__('Administrator').'</th>
							<th style="text-align:center;">'.__('Editor').'</th>
							<th style="text-align:center;">'.__('Author').'</th>
							<th style="text-align:center;">'.__('Contributor').'</th>
							<th style="text-align:center;">'.__('Subscriber').'</th>
						</tr>
					</thead>

					<tbody>
				';

				$i = 0;
				foreach ($categorys as $category){
					echo '<tr style="text-align:center; '.$odd[($i%2)].'">';
						echo '<th>'. $category->cat_name .'</th>';
						echo '<td><input class="category_id_role" type="checkbox" DISABLED></td>';
						echo '<td><input class="category_id_role" type="checkbox" name="capa_protect_cat[editor]['.$category->term_id.']" '.(($category_check_role_editor[$category->term_id]) ? 'checked' : NULL).'></td>';
						echo '<td><input class="category_id_role" type="checkbox" name="capa_protect_cat[author]['.$category->term_id.']" '.(($category_check_role_author[$category->term_id]) ? 'checked' : NULL).'></td>';
						echo '<td><input class="category_id_role" type="checkbox" name="capa_protect_cat[contributor]['.$category->term_id.']" '.(($category_check_role_contributor[$category->term_id]) ? 'checked' : NULL).'></td>';
						echo '<td><input class="category_id_role" type="checkbox" name="capa_protect_cat[subscriber]['.$category->term_id.']" '.(($category_check_role_subscriber[$category->term_id]) ? 'checked' : NULL).'></td>';
					echo '</tr>';
					$i++;
				}

			echo '
					</tbody>
				</table>
			';


  // --------------------------------------------------------------
  // ---- Pages --- //
  // --------------------------------------------------------------
		if($pages){
	
			echo '
			
				<table class="form-table">
					<thead style="background:#E6E6E6;">
						<tr>
							<th><b>'.__('Pages','capa').'</b></th>
							<th style="text-align:center;">'.__('Administrator').'</th>
							<th style="text-align:center;">'.__('Editor').'</th>
							<th style="text-align:center;">'.__('Author').'</th>
							<th style="text-align:center;">'.__('Contributor').'</th>
							<th style="text-align:center;">'.__('Subscriber').'</th>
						</tr>
					</thead>

					<tbody>
				';
				$i = 0;
				foreach ($pages as $page){

					echo '<tr style="text-align:center; '.$odd[($i%2)].'">';
						echo '<th>'. $page->post_title .'</th>';
						echo '<td><input class="page_id_role" type="checkbox" DISABLED></td>';
						echo '<td><input class="page_id_role" type="checkbox" name="capa_protect_pag[editor]['.$page->ID.']" '.(($page_check_role_editor[$page->ID]) ? 'checked' : NULL).'></td>';
						echo '<td><input class="page_id_role" type="checkbox" name="capa_protect_pag[author]['.$page->ID.']" '.(($page_check_role_author[$page->ID]) ? 'checked' : NULL).'></td>';
						echo '<td><input class="page_id_role" type="checkbox" name="capa_protect_pag[contributor]['.$page->ID.']" '.(($page_check_role_contributor[$page->ID]) ? 'checked' : NULL).'></td>';
						echo '<td><input class="page_id_role" type="checkbox" name="capa_protect_pag[subscriber]['.$page->ID.']" '.(($page_check_role_subscriber[$page->ID]) ? 'checked' : NULL).'></td>';
					echo '</tr>';
					$i++;
				}

			echo '
					</tbody>
				</table>
			';
		}

			echo '
				<p class="submit" style="float:left; margin-right:10px;">
					<input type="submit" name="submit" value="'. __('Update Role Options','capa') .'  &raquo;" /> 
				</p>
				<p class="submit">
					<input type="submit" name="submit" value="'. __('Reset Role Options','capa').'" />
				</p>
				</form>';
	}

// capa_sublevel_users() displays the page content for the users submenu
	function capa_sublevel_users() {
			echo '<div class="wrap">';
			echo '<h2 style="margin-bottom:15px;">' . __('CaPa Anonymous Users','capa') . '</h2>';

		  	// --------------------------------------------------------------

			echo '
			<script language="javascript">
			function check_categories(class,checked)
			{
				the_form = document.capa_protect;

				all_check_boxes = the_form.getElementsByTagName(\'input\');

				for (var i = 0; i < all_check_boxes.length; i++)
					if (all_check_boxes[i].className == class)
						all_check_boxes[i].checked = checked;
			}
			</script>
			';

			echo '<form name="capa_protect" method="post" action="'.$page_uri.'">';

		  // --------------------------------------------------------------

	echo '<fieldset style="border:1px solid #CCCCCC; padding-left:10px;"><legend>'. __('Categories','capa') .'</legend>';

		$categorys = get_categories('hide_empty=0&hierarchical=1');

		echo '<table><tr>';
		/*
			echo '<td>';

				// Category table
				print '<h3>'. __('Category Access for New Users','capa').'</h3>';

				print '<p>'. __('Set the default visibility of categories for new users below. These values can be set on a user-by-user basis in the management page.','capa').'</p>';

				$category_check = get_option("capa_protect_cat_default");

					$test = $categorys;
					
					foreach($test as $item=>$value){
						if($value->category_parent == 0){
						}
					}

				echo '<p>';

				foreach ($categorys as $category){
					echo '<input  class="category_id_default" type="checkbox" name="capa_protect_cat_'.$category->term_id.'_default"';

					if ($category_check[$category->term_id] == true)
						echo  'checked';

					echo '> '. $category->cat_name .'<br/>';

				}

				echo '</p>';
			echo '</td>';


		  // --------------------------------------------------------------

			echo '<td style="padding-left:10px;">';
		*/
			echo '<td>';
				// Category table
				echo '<h3>'. __('Category Access for Anonymous Users','capa') .'</h3>';

				echo '<p>' . __('Set the visibility of categories for users that are not logged in below. Usually this is the same as or more restrictive than the access granted to new users.','capa').'</p>';

#				$categorys = get_categories('hide_empty=0&hierarchical=1');
				$category_check = get_option("capa_protect_cat_anonymous");

		#		usort($categorys);

				echo '<p>';

				foreach ($categorys as $category) {
					echo '<input  class="category_id_anonymous" type="checkbox" name="capa_protect_cat_anonymous['.$category->term_id.']"';

					if ($category_check[$category->term_id] == true)
						echo ' checked';

					echo '> ' . $category->cat_name . '<br/>';
				}

				echo '</p>';

			echo '</td></tr>';

/*
			echo '<tr><td>';

		// Buttons Categorie New User
				echo '
					<p class="submit" style="padding-bottom:0px;">
						<input name="check_all_categories_default" type="button" id="check_all_categories_default" value="'. __('Check all categories','capa') .'" onClick="check_categories(\'category_id_default\',true)">
						</p>
					<p class="submit" style="padding-top:0px;">
						<input name="uncheck_all_categories_default" type="button" id="uncheck_all_categories_default" value="'. __('Uncheck all categories','capa') .'" onClick="check_categories(\'category_id_default\',false)">
					</p>
				';

			echo '</td><td>';
*/
			echo "<tr><td>";
		// Buttons Categorie Anonymous User
				echo '<p class="submit" style="float:left; margin-right:10px;">
				<input name="check_all_categories_anonymous" type="button" id="check_all_categories_anonymous" value="'. __('Check all categories','capa') .'" 
				onClick="check_categories(\'category_id_anonymous\',true)">
				</p>
				<p class="submit">
				<input name="uncheck_all_categories_anonymous" type="button" id="uncheck_all_categories_anonymous" value="' . __('Uncheck all categories','capa') .'" 
				onClick="check_categories(\'category_id_anonymous\',false)">
				</p>
				';
			
			echo '</td></tr>';

		echo '</table>';
	echo '</fieldset>';

	echo '<br>';

		  // --------------------------------------------------------------
		  // ---- PAGES --- //
		  // --------------------------------------------------------------

	echo '<fieldset style="border:1px solid #CCCCCC; padding-left:10px;"><legend>'. __('Pages','capa') . '</legend>';
		$pages_ids = & get_pages($args);		

				#print "<hr style=\"border:0px; height:1px; background-color:#CCCCCC; \">";
		echo '<table>';
			echo '<tr>';
/*
			echo '<td>';

				// Page Table New User / Registered
				echo '<h3>'. __('Pages Access for New Users','capa') .'</h3>';

				echo '<p>'. __('Set the default visibility of pages for new users below. These values can be set on a user-by-user basis in the management page.','capa') . '</p>';

				$pages_check = get_option("capa_protect_pag_default");

				#usort($pages_ids);

				foreach ($pages_ids as $page_id) {
				echo '<input  class="pages_id_default" type="checkbox" ' .
					'name="capa_protect_pag_'.$page_id->ID.'_default""';

				if ($pages_check[$page_id->ID] == true)
					echo ' checked';

				echo '> ' . $page_id->post_title . '<br/>';
				}

				echo '</p>';

			echo '</td>';

		  // --------------------------------------------------------------

			echo '<td style="padding-left:10px;">';
*/
			echo '<td>';
				// Page Table Anonymous User
				echo '<h3>'. __('Page Access for Anonymous Users','capa') . '</h3>';

				echo '<p>'. __('Set the visibility of pages for users that are not logged in below. Usually this is the same as or more restrictive than the access granted to new users.','capa') . '</p>';

				$pages_ids = & get_pages($args);		
				$pages_check = get_option("capa_protect_pag_anonymous");

				#usort($pages_ids);

				foreach ($pages_ids as $page_id) {
				echo '<input  class="pages_id_anonymous" type="checkbox" name="capa_protect_pag_anonymous['.$page_id->ID.']"';

				if ($pages_check[$page_id->ID] == true)
					echo ' checked';

				echo '> ' . $page_id->post_title . '<br/>';
				}

				echo '</p>';

			echo '</td></tr>';
			echo '<tr>';
/*
				echo '<td>';
			// Button New User Pages
					echo '<p class="submit" style="padding-bottom:0px;">
					<input name="check_all_pages_default" type="button" id="check_all_pages_default" value="' . __('Check all pages','capa') .'" 
					onClick="check_categories(\'pages_id_default\',true)">
					</p>

					<p class="submit" style="padding-top:0px;">
					<input name="uncheck_all_pages_default" type="button" id="uncheck_all_pages_default" value="'. __('Uncheck all pages','capa') .'" 
					onClick="check_categories(\'pages_id_default\',false)">
					</p>
					';
				echo '</td>';
*/
				echo '<td>';
			// Button Anonymous User Pages
					echo '<p class="submit" style="float:left; margin-right:10px;">
					<input name="check_all_pages_anonymous" type="button" id="check_all_pages_anonymous" value="'. __('Check all pages','capa'). '" 
					onClick="check_categories(\'pages_id_anonymous\',true)">
					</p>

					<p class="submit">
					<input name="uncheck_all_pages_anonymous" type="button" id="uncheck_all_pages_anonymous" value="'. __('Uncheck all pages','capa') .'" 
					onClick="check_categories(\'pages_id_anonymous\',false)">
					</p>
					';
				echo '</td>';
			echo '</tr>';
		echo '</table>';
	echo '</fieldset>';

			echo '
				<p class="submit" style="float:left; margin-right:10px;">
					<input type="submit" name="submit" value="'. __('Update User Options','capa') .'  &raquo;" /> 
				</p>
				<p class="submit">
					<input type="submit" name="submit" value="'. __('Reset User Options','capa').'" />
				</p>
				</form>';
	}

	function handle_action() {
		global $_POST;

		if ($_POST['submit'] == __('Reset Global Options','capa')) {
			delete_option('capa_protect_private_message');
			delete_option('capa_protect_post_policy');
			delete_option('capa_protect_show_padlock_on_private_posts');

			delete_option('capa_protect_show_title_in_feeds');

			delete_option("capa_protect_comment_policy");
			delete_option("capa_protect_show_comment_on_private_posts");

			delete_option('capa_protect_show_private_categories');
			delete_option('capa_protect_show_padlock_on_private_categories');

			delete_option('capa_protect_show_private_pages');

			delete_option("capa_protect_advance_policy");

		}

		if ($_POST['submit'] == __('Reset User Options','capa')) {

			delete_option("capa_protect_cat_default");
			delete_option("capa_protect_cat_anonymous");

			delete_option("capa_protect_pag_default");
			delete_option("capa_protect_pag_anonymous");
		}

		if($_POST['submit'] == __('Reset Role Options','capa')){
			delete_option("capa_protect_cat_role_editor");
			delete_option("capa_protect_cat_role_author");
			delete_option("capa_protect_cat_role_contributor");
			delete_option("capa_protect_cat_role_subscriber");

			delete_option("capa_protect_pag_role_editor");
			delete_option("capa_protect_pag_role_author");
			delete_option("capa_protect_pag_role_contributor");
			delete_option("capa_protect_pag_role_subscriber");
		}


		if(strpos($_POST['submit'], __('Update User Options','capa')) !== FALSE){

			if(is_array($_POST['capa_protect_cat_anonymous'])){
				foreach($_POST['capa_protect_cat_anonymous'] as $id=>$value){
					$tmp['capa_protect_cat_anonymous'][$id] = TRUE;
				}

				update_option('capa_protect_cat_anonymous',$tmp['capa_protect_cat_anonymous']);
			}else{
				delete_option("capa_protect_cat_anonymous");
			}

			if(is_array($_POST['capa_protect_pag_anonymous'])){
				foreach($_POST['capa_protect_pag_anonymous'] as $id=>$value){
					$tmp['capa_protect_pag_anonymous'][$id] = TRUE;
				}

				update_option('capa_protect_pag_anonymous',$tmp['capa_protect_pag_anonymous']);
			}else{
				delete_option("capa_protect_pag_anonymous");
			}

			
			if ($_POST['capa_protect_show_padlock_on_private_posts'] == 'on'){
				update_option('capa_protect_show_padlock_on_private_posts', true);
			}else{
				update_option('capa_protect_show_padlock_on_private_posts', false);
			}

		}

		if(strpos($_POST['submit'],__('Update Role Options','capa')) !== FALSE) {

			if(is_array($_POST['capa_protect_cat'])){
				foreach($_POST['capa_protect_cat'] as $user=>$value){
					foreach($value as $id=>$wert){
						$tmp['cat'][$user][$id] = TRUE;
					}
				}


				(is_null($tmp['cat']['editor']))		? delete_option('capa_protect_cat_role_editor')		: update_option('capa_protect_cat_role_editor',$tmp['cat']['editor']);
				(is_null($tmp['cat']['author']))		? delete_option('capa_protect_cat_role_author')		: update_option('capa_protect_cat_role_author',$tmp['cat']['author']);
				(is_null($tmp['cat']['contributor']))	? delete_option('capa_protect_cat_role_contributor'): update_option('capa_protect_cat_role_contributor',$tmp['cat']['contributor']);
				(is_null($tmp['cat']['subscriber']))	? delete_option('capa_protect_cat_role_subscriber')	: update_option('capa_protect_cat_role_subscriber',$tmp['cat']['subscriber']);
			}

			if(is_array($_POST['capa_protect_pag'])){
				foreach($_POST['capa_protect_pag'] as $user=>$value){
					foreach($value as $id=>$wert){
						$tmp['pag'][$user][$id] = TRUE;
					}
				}

				(is_null($tmp['cat']['editor']))		? 	delete_option('capa_protect_pag_role_editor')		:	update_option('capa_protect_pag_role_editor'		,$tmp['pag']['editor']);
				(is_null($tmp['cat']['author']))		? 	delete_option('capa_protect_pag_role_author')		:	update_option('capa_protect_pag_role_author'		,$tmp['pag']['author']);
				(is_null($tmp['cat']['contributor']))	? 	delete_option('capa_protect_pag_role_contributor')	:	update_option('capa_protect_pag_role_contributor'	,$tmp['pag']['contributor']);
				(is_null($tmp['cat']['subscriber']))	? 	delete_option('capa_protect_pag_role_subscriber')	:	update_option('capa_protect_pag_role_subscriber'	,$tmp['pag']['subscriber']);
			}

		}
		
		if(strpos($_POST['submit'], __('Update Global Options','capa')) !== FALSE){

			// Comment Update
			update_option('capa_protect_post_policy',					$_POST['capa_protect_post_policy']);

			update_option('capa_protect_comment_policy',				$_POST['capa_protect_comment_policy']);
			update_option('capa_protect_show_comment_on_private_posts',	$_POST['capa_protect_show_comment_on_private_posts']);
			update_option('capa_protect_private_message',				$_POST['capa_protect_private_message']);


			if ($_POST['capa_protect_show_private_message'] == 'on'){
				update_option('capa_protect_show_private_message', true);
			}else{
				update_option('capa_protect_show_private_message', false);
			}

			if ($_POST['capa_protect_show_title_in_feeds'] == 'on'){
				update_option('capa_protect_show_title_in_feeds', true);
			}else{
				update_option('capa_protect_show_title_in_feeds', false);
			}


		// Remove Option from old Capa Versions
#			delete_option('capa_protect_show_private_message',false);
			delete_option('capa_protect_advance_policy',false);
			delete_option('capa_protect_cat_default',false);
			delete_option('capa_protect_pag_default',false);

			if ($_POST['capa_protect_show_private_categories'] == 'on'){
				update_option('capa_protect_show_private_categories', true);
			}else{
				update_option('capa_protect_show_private_categories', false);
			}

			if ($_POST['capa_protect_show_padlock_on_private_categories'] == 'on'){
				update_option('capa_protect_show_padlock_on_private_categories', true);
			}else{
				update_option('capa_protect_show_padlock_on_private_categories', false);
			}

			if ($_POST['capa_protect_show_private_pages'] == 'on'){
				update_option('capa_protect_show_private_pages', true);
			}else{
				update_option('capa_protect_show_private_pages', false);
			}

		}
	}

?>
